<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Base\Domain;

use Base\Model\Apps as AppsModel;

class Apps extends Base{

    public function getAppSecret($appKey) {
        $model = new AppsModel();
        $cfg = $model->getBy('app_key', $appKey, false, 'app_secret');
        return $cfg ? $cfg['app_secret'] : null;
    }

    public function getMyApp($uid, $appKey) {
        $where = array('uid' => $uid, 'app_key' => $appKey);
        $select = 'app_key,app_secret,app_name,app_status,verify_status,add_time,app_icon,apply_reason,app_owner';
        $app = AppsModel::model()->getData($where, array(), $select);
        return $app;
    }

    public function updateMyApp($uid, $appKey, $updateData) {
        $where = array('uid' => $uid, 'app_key' => $appKey);
        return !empty($updateData) ? AppsModel::model()->updateAll($where, $updateData) : false;
    }
    
    public function getApp($appKey, $select = '*') {
        $model = new AppsModel();
        $cfg = $model->getBy('app_key', $appKey, false, $select);
        return $cfg;
    }

    public function getAppById($id, $fields = '*') {
        if ($id <= 0) {
            return array();
        }
        $model = new AppsModel();
        $data = $model->get($id, $fields);
        if(!empty($data)){
            $domain = new User();
            $map = $domain->getUserNameByUid(array($data['uid']));
            $data['uidName'] = isset($map[$data['uid']]) ? $map[$data['uid']] : '未知';
        }
        return $data;
    }

    // 管理员：获取所有的应用
    public function getAllApp($appKey = NULL, $appName = NULL, $verifyStatus = NULL, $page = 1, $perpage = 100){
        $model = new AppsModel();
        $where = array();
        $whereParam = array();
        if (!empty($appKey)) {
            $where['app_key'] = $appKey;
        }
        if (!empty($appName)) {
            $where['app_name LIKE ?'] = "%{$appName}%";
        }
        if ($verifyStatus !== null) {
            $where['verify_status'] = $verifyStatus;
        }
        $list = $model->getListEx(
            $where,
            $whereParam,
            '*',
            'id DESC',
            $page,
            $perpage
        );
        $rows = $list['items'];

        $requestLimitDomain = new RequestLimitLog();
        $requestMap = $requestLimitDomain->getAllKeyRequest();
        
        foreach ($rows as &$itRef) {
            $appKey = $itRef['app_key'];
            // 隐藏密钥
            $itRef['app_secret'] = substr_replace($itRef['app_secret'], '******', 3, -3);
            $itRef['today_request'] = isset($requestMap[$appKey]) ? intval($requestMap[$appKey]) : 0;

            // 不显示RSA公钥密钥
            unset($itRef['rsa_private_key'], $itRef['rsa_public_key']);
        }

        $uids = array_column($rows, 'uid');
        $userDomain = new User();
        $map = $userDomain->getUserNameByUid($uids);
        foreach ($rows as &$item){
            $item['uidName'] = isset($map[$item['uid']]) ? $map[$item['uid']] : '未知';
        }
        return array('list' => $rows, 'total' => $list['total']);
    }
    
    public function getUserAllApp($uid) {
        $select = 'app_key,app_name,app_status,add_time,app_owner,verify_status,app_secret,app_icon';
        $where = array('uid' => $uid);
        $whereParams = array();
        $order = 'id ASC';
        $topNum = 500;
        
        $model = new AppsModel();
        return $model->getTopList($select, $where, $whereParams, $order, $topNum);
    }
    
    // 获取下拉列表
    public function getAppDropdownList($appName, $topNum = 1000) {
        $model = new AppsModel();
        $where = '';
        $whereParam = array();
        if(!empty($appName)){
            $where = 'app_name LIKE ?';
            $whereParam = array("%{$appName}%");
        }
        $list = $model->getListEx(
            $where,
            $whereParam,
            'app_key, app_name',
            'id',
            1,
            $topNum
         );
        $rows = $list['items'];
        
        return array('list' => $rows, 'total' => $list['total']);;
    }

    public function alterAppStat($id, $status){
        $model = new AppsModel();
        return $model->updateBy('id', $id, array('app_status' => $status));
    }

    public function verifyAppStat($id, $verifyStatus){
        $model = new AppsModel();
        return $model->updateBy('id', $id, array('verify_status' => $verifyStatus));
    }

    public function addApp($appName, $appKey, $appSecret, $appLimit = 0, $uid = 0, $appOwner = '', $verifyStatus = 0, $moreInfo = array()){
        $app = $this->getApp($appKey, 'id');
        if (!empty($app)) {
            return false;
        }

        $data = array(
            'app_name' => $appName, 
            'app_key' => $appKey, 
            'app_secret' => $appSecret,
            'add_time' => date('Y-m-d H:i:s'),
            'app_limit' => intval($appLimit),
            'uid' => intval($uid),
            'app_owner' => $appOwner,
            'verify_status' => intval($verifyStatus),
        );

        // 为每个应用生成公钥私钥，以便各应用进行数据加密
        if (function_exists('openssl_pkey_export')) {
            $keyG = new \PhalApi\Crypt\RSA\KeyGenerator();
            $data['rsa_private_key'] = $keyG->getPriKey();
            $data['rsa_public_key'] = $keyG->getPubKey();
        }
        
        if (!empty($moreInfo) && is_array($moreInfo)) {
            $data = array_merge($moreInfo, $data);
        }
        
        $model = new AppsModel();
        return $model->insert($data);
    }

    public function editApp($id, $appName = null, $appSecret = null, $appLimit = null, $uid = null, $verifyStatus = null, $appIcon = null, $applyReason = null, $allowIps = null){
        $updateData = array();
        if($appName !== null){
            $updateData['app_name'] = $appName;
        }
        if($appSecret !== null){
            $updateData['app_secret'] = $appSecret;
        }
        if ($appLimit !== null){
            $updateData['app_limit'] = intval($appLimit);
        }
        if ($uid !== null) {
            $updateData['uid'] = $uid;
        }
        if ($verifyStatus !== null) {
            $updateData['verify_status'] = $verifyStatus;
        }
        if ($appIcon !== null) {
            $updateData['app_icon'] = $appIcon;
        }
        if ($applyReason !== null) {
            $updateData['apply_reason'] = $applyReason;
        }
        if ($allowIps !== null) {
            $updateData['allow_ips'] = $allowIps;
        }
        if(empty($updateData)){
            return false;
        }else{
            $model = new AppsModel();
            return $model->update($id, $updateData);
        }
    }
    
    public function getUserAppTotalNum($uid) {
        return AppsModel::model()->count(array('uid' => intval($uid)));
    }
    
    public function getToVerifyAppNum() {
        return AppsModel::model()->count(array('verify_status' => 0));
    }


    public function getMyToVerifyAppNum() {
        return AppsModel::model()->count(array('verify_status' => 1,'app_status'=>1,'uid'=>$this->getUid()));
    }

    public function getAppLimit($appKey) {
        return AppsModel::model()->getValueBy('app_key', $appKey, 'app_limit');
    }

    // 获取允许访问的IP白名单
    public function getAppAllowIps($appKey) {
        $ips = AppsModel::model()->getValueBy('app_key', $appKey, 'allow_ips');
        return !empty($ips) && $ips !== 'null' ? explode(',', $ips) : array(); // fixed null 字符串
    }

    // 根据app_key，获取相应的开发者等级
    public function getAppUserLevel($appKey) {
        if (empty($appKey)) {
            return 0;
        }

        $row = AppsModel::notorm()->select('a.id, m.member_level')
            ->alias('a')
            ->where('a.app_key', $appKey)
            ->leftJoin('member', 'm', 'a.uid = m.id')
            ->fetchOne();

        return $row ? intval($row['member_level']) : 0;
    }
    
}
